unit uWinIpHlpApi;

{$mode objfpc}{$H+}

interface

uses
  Windows, Winsock2, Sockets, SysUtils;
  
type
  TSOCKET_ADDRESS = record
    lpSockaddr: PSockAddr;
    iSockaddrLength: Integer;
  end;

type
  PIP_ADAPTER_UNICAST_ADDRESS_LH = ^TIP_ADAPTER_UNICAST_ADDRESS_LH;

  TIP_ADAPTER_UNICAST_ADDRESS_LH = record
    Alignment: record
      case boolean of
        True: (Alignment: ULONGLONG);
        False: (Length: ULONG;
                FLAGS: DWORD);
    end;
    Next: PIP_ADAPTER_UNICAST_ADDRESS_LH;
    Address: TSOCKET_ADDRESS;
    PrefixOrigin: integer;
    SuffixOrigin: integer;
    DadState: integer;
    ValidLifetime: ULONG;
    PreferredLifetime: ULONG;
    LeaseLifetime: ULONG;
    OnLinkPrefixLength: ULONG;
  end;

type
  PIP_ADAPTER_ANYCAST_ADDRESS_XP = ^TIP_ADAPTER_ANYCAST_ADDRESS_XP;

  TIP_ADAPTER_ANYCAST_ADDRESS_XP = record
    Alignment: record
      case boolean of
        True: (Alignment: ULONGLONG);
        False: (Length: ULONG;
          FLAGS: DWORD);
    end;
    Next: PIP_ADAPTER_ANYCAST_ADDRESS_XP;
    Address: TSOCKET_ADDRESS;
  end;

  PIP_ADAPTER_MULTICAST_ADDRESS_XP = PIP_ADAPTER_ANYCAST_ADDRESS_XP;
  TIP_ADAPTER_MULTICAST_ADDRESS_XP = TIP_ADAPTER_ANYCAST_ADDRESS_XP;

  // eigentlich müsste Alignment.Flags durch Alignment.Reserved getauscht werden, ich bin aber faul
  PIP_ADAPTER_DNS_SERVER_ADDRESS_XP = PIP_ADAPTER_ANYCAST_ADDRESS_XP;
  TIP_ADAPTER_DNS_SERVER_ADDRESS_XP = TIP_ADAPTER_ANYCAST_ADDRESS_XP;

  PIP_ADAPTER_WINS_SERVER_ADDRESS_LH = PIP_ADAPTER_ANYCAST_ADDRESS_XP;
  TIP_ADAPTER_WINS_SERVER_ADDRESS_LH = TIP_ADAPTER_ANYCAST_ADDRESS_XP;

  PIP_ADAPTER_GATEWAY_ADDRESS_LH = PIP_ADAPTER_ANYCAST_ADDRESS_XP;
  TIP_ADAPTER_GATEWAY_ADDRESS_LH = TIP_ADAPTER_ANYCAST_ADDRESS_XP;

const
  MAX_DNS_SUFFIX_STRING_LENGTH = 256;
type
  PIP_ADAPTER_DNS_SUFFIX = ^TIP_ADAPTER_DNS_SUFFIX;

  TIP_ADAPTER_DNS_SUFFIX = record
    Next: PIP_ADAPTER_DNS_SUFFIX;
    Str: array[0..MAX_DNS_SUFFIX_STRING_LENGTH - 1] of WCHAR;
  end;

type
  PIP_ADAPTER_PREFIX_XP = ^TIP_ADAPTER_PREFIX_XP;

  TIP_ADAPTER_PREFIX_XP = record
    Alignment: record
      case boolean of
        True: (Alignment: ULONGLONG);
        False: (Length: ULONG;
                FLAGS: DWORD);
    end;
    Next: PIP_ADAPTER_PREFIX_XP;
    Address: TSOCKET_ADDRESS;
    PrefixLength: ULONG;
  end;

const
  MAX_ADAPTER_ADDRESS_LENGTH = 8;
  MAX_DHCPV6_DUID_LENGTH = 130;

  // see https://docs.microsoft.com/de-de/window ... dresses_lh
type
  PIP_ADAPTER_ADDRESSES = ^TIP_ADAPTER_ADDRESSES;

  TIP_ADAPTER_ADDRESSES = record
    Alignment: record
      case boolean of
        True: (Alignment: ULONGLONG);
        False: (Length, IfIndex: ULONG);
    end;
    Next: PIP_ADAPTER_ADDRESSES;
    AdapterName: PChar;
    FirstUnicastAddress: PIP_ADAPTER_UNICAST_ADDRESS_LH;
    FirstAnycastAddress: PIP_ADAPTER_ANYCAST_ADDRESS_XP;
    FirstMulticastAddress: PIP_ADAPTER_MULTICAST_ADDRESS_XP;
    FirstDNSServerAddress: PIP_ADAPTER_DNS_SERVER_ADDRESS_XP;
    DnsSuffix: PWCHAR;
    Description: PWCHAR;
    FriendlyName: PWCHAR;
    PhysicalAddress: array[0..MAX_ADAPTER_ADDRESS_LENGTH - 1] of byte;
    PhysicalAddressLength: ULONG;
    Flags: record
      case boolean of
        True: (Flags: boolean);
        False: (BitFlags: bitpacked record
            DdnsEnabled,
            RegisterAdapterSuffix,
            Dhcpv4Enabled,
            ReceiveOnly,
            NoMulticast,
            Ipv6OtherStatefulConfig,
            NetbiosOverTcpipEnabled,
            Ipv4Enabled, Ipv6Enabled,
            Ipv6ManagedAddressConfigurationSupported: boolean;
          end;
        );
    end;
    Mtu: ULONG;
    //Enums in C => Ints/cardinals/ULONGS/32 bit
    IfType: ULONG;
    OperStatus: ULONG;
    Ipv6IFIndex: ULONG;
    ZoneIndices: array[0..15] of ULONG;
    FirstPrefix: PIP_ADAPTER_PREFIX_XP;
    TransmitLinkSpeed,
    ReceiveLinkSpeed: ULONG64;
    FirstGatewayAddress: PIP_ADAPTER_GATEWAY_ADDRESS_LH;
    Ipv4Metric,
    Ipv6Metric: ULONG;
    //IF_LUID
    LUID: ULONG64;
    DHCPv4Server: TSOCKET_ADDRESS;
    // NET_IF_COMPARTMENT_ID = UINT32
    CompartmentId: UInt32;
    NetworkGuid: Windows.GUID;
    // NET_IF_CONNECTION_TYPE, TUNNEL_TYPE = enum
    ConnectionType: ULONG;
    TunnelType: ULONG;
    Dhcpv6Server: TSOCKET_ADDRESS;
    Dhcpv6ClientDuid: array[0..MAX_DHCPV6_DUID_LENGTH - 1] of byte;
    Dhcpv6ClientDuidLength: ULONG;
    Dhcpv6Iaid: ULONG;
    FirstDnsSuffix: PIP_ADAPTER_DNS_SUFFIX;
  end;

function GetAdaptersAddresses(Family: ULONG;
                              Flags: DWORD;
                              Reserved: PVOID;
                              pAdapterAddresses: PIP_ADAPTER_ADDRESSES;
                              pOutBufLen: PULONG
                              ): DWORD; stdcall; external 'iphlpapi.dll' name 'GetAdaptersAddresses';



function ConvertLengthToIpv4Mask(MaskLength: ULONG;
                                 Mask: PULONG
                                 ): DWORD; stdcall; external 'iphlpapi.dll' name 'ConvertLengthToIpv4Mask';




implementation





end.

